pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if


if (theVersion <> "") then

	if(InStr(UCase(theVersion),"CC") > 0)then
		Set myInDesign = CreateObject("InDesign.Application." & theVersion)
	else
		Set myInDesign = CreateObject("InDesign.Application.CS" & theVersion)
	end if

	
	If myInDesign.Documents.Count <> 0 Then	
		Dim replaceIt
					
		replaceIt = MsgBox("Clear all configured data?", vbYesNo, "Clear All")
		continueOn = (replaceIt = vbYes)
	
		if continueOn then
	
			'Clear document info
			myInDesign.Documents(1).Label = ""
			myInDesign.Documents(1).InsertLabel "rows", ""
			myInDesign.Documents(1).InsertLabel "cols", ""
			myInDesign.Documents(1).InsertLabel "styleCode", ""
			myInDesign.Documents(1).InsertLabel "group", ""
			myInDesign.Documents(1).InsertLabel "hotFolder", ""
			myInDesign.Documents(1).InsertLabel "prodAccess", ""
			
			
			
			'Clear element info
			set allElems = myInDesign.Documents(1).PageItems
		
			For myCounter = 1 To allElems.Count
				set myObject = allElems(myCounter)
				
				select case myObject.ExtractLabel("type")
					case "text"
						myObject.InsertLabel "defaultTxt", ""
						myObject.InsertLabel "maxChars", ""
						myObject.InsertLabel "autoFill", ""
						myObject.InsertLabel "dingbat", ""
						myObject.InsertLabel "startOfLine", ""
						myObject.InsertLabel "numberOfLines", ""
						myObject.InsertLabel "characterWidth", ""
						myObject.InsertLabel "minPointSize", ""
						myObject.InsertLabel "maxPointSize", ""
						myObject.InsertLabel "fitMethod", ""
						myObject.InsertLabel "allowWysiwyg", ""
						myObject.InsertLabel "disableSpellcheck", ""
						myObject.InsertLabel "blind", ""
						myObject.InsertLabel "subEdit", ""

					case "flash"
						myObject.InsertLabel "maxChars", ""
						myObject.InsertLabel "numberOfLines", ""
						myObject.InsertLabel "characterWidth", ""
						myObject.InsertLabel "minPointSize", ""
						myObject.InsertLabel "maxPointSize", ""
						myObject.InsertLabel "fitMethod", ""
						myObject.InsertLabel "disableSpellcheck", ""
						myObject.InsertLabel "autoFill", ""
												
					case "image"
						myObject.InsertLabel "fitMethod", ""
						myObject.InsertLabel "imageType", ""
						myObject.InsertLabel "imageAction", ""
						myObject.InsertLabel "allowCropping", ""
						
					case "area"
						myObject.InsertLabel "rows", ""
						myObject.InsertLabel "cols", ""
						myObject.InsertLabel "styleCode", ""			
				end select
				
				
				myObject.Label = ""
				myObject.InsertLabel "type", ""
				myObject.InsertLabel "sort", ""
			Next
	
			MsgBox ("Clear Complete")
		end if
	Else
		MsgBox ("Please open a document.")
	End If
else
	MsgBox ("Please configure your scripts.")
end if


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function