pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if

if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)
	
	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then
		vtList = "Document Fonts:" + VBCR
		
		For myCounter = 1 To myInDesign.ActiveDocument.Fonts.Count
			vtList = vtList + myInDesign.ActiveDocument.Fonts(myCounter).PostScriptName + "|" + replace(myInDesign.ActiveDocument.Fonts(myCounter).Name, chr(9)," ") + "|" + myInDesign.ActiveDocument.Fonts(myCounter).Location + VBCR
		Next


		set charStyles = myInDesign.Documents(1).CharacterStyles
		vtList = vtList + VBCR + VBCR + "Character Style Fonts:" + VBCR
		
		For myCounter = 1 To charStyles.Count
			set currentStyle = charStyles(myCounter)
			
			if(currentStyle.Name <> "[None]") then
				vtList = vtList + setData("", returnStyleFontFace(currentStyle)) + VBCR
			end if
		Next


		MsgBox (vtList)
	end if
else
	MsgBox ("Please configure your scripts.")
end if


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


function returnStyleFontFace (currentStyle)
	returnVal = ""
	
	Set myTextFrame = myInDesign.ActiveDocument.TextFrames.Add
	

	'Fix for wrap round breaking the box
	theWidth = myInDesign.ActiveDocument.documentPreferences.PageWidth
	theHeight = myInDesign.ActiveDocument.documentPreferences.PageHeight
	
	setSize=Array(0,0,theHeight,theWidth)
	myTextFrame.GeometricBounds = setSize
	
	myTextFrame.Contents = "a"
	myTextFrame.characters(1).AppliedCharacterStyle = currentStyle
	
	
	'if we error then we do not have the font on the local machine
	on error resume next
	returnVal = myTextFrame.characters(1).AppliedFont.Location
	
	if err.number <> 0 then 
		returnVal = "character style '" & currentStyle.name & "' has a missing font"
	else
		vlPos = InStrRev(returnVal,"\") + 1
		returnVal = Mid(returnVal,vlPos)
	end if
	
	
	'delete the new frame
	myTextFrame.delete
	
	
	returnStyleFontFace = returnVal
end function


function setData (elemName, elemValue)
	'setData = elemName & theDelimeter & elemValue & theDelimeter
	setData = elemName & theDelimeter & elemValue & theDelimeter
end function