pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if

Dim arrAction
arrAction = Array("Complete:")

if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)
	
	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then
		
		goOn = MsgBox("Are you sure you want to replace the document fonts?", vbYesNo, "Change Document Fonts")
		if(goOn = vbYes) then
			
			'Get font list
			'theFontData = DownloadLongText("http://192.168.1.77/quickfix/font_replace_list.a4d")
			theFontData = DownloadLongText("http://demo.promotor2.com/engine/extras/font_replace_list.txt?unique=" & CreateGUID)

			'msgbox("http://demo.promotor2.com/engine/extras/font_replace_list.txt?unique=" & CreateGUID)
			'msgbox(theFontData)

			if(theFontData = "")then
				msgbox("Failed to download font data.")
			else
				'arrFonts = Split(theFontData, vbCrlf)
				arrFonts = Split(theFontData, Chr(10))

				'Set page count
				set allPages = myInDesign.ActiveDocument.Pages

				'Loop through pages
				For myPageCount = 1 To allPages.Count

					set allElems = myInDesign.ActiveDocument.Pages(CInt(myPageCount)).PageItems
					
					'loop through all elements
					For myCounter = 1 To allElems.Count
						set currentElem = allElems(myCounter)
					
						if (TypeName(currentElem) = "TextFrame") then

							if(currentElem.contents = "")then
								currentElem.contents = "a"
							end if

							For myCharCounter = 1 To currentElem.characters.count
								'Get postscript name
								postscriptName = currentElem.characters(myCharCounter).appliedFont
								
								displayName = Replace(postscriptName,vbTab,"{tab}")
								displayName = Replace(displayName, " ","{space}")
								'msgbox("'" & displayName & "'")
								
								thePosition=findInArray(arrFonts,postscriptName & ":")
								'msgbox(thePosition)

								if(thePosition <> -1) then	
										'msgbox(arrFonts(thePosition))
										arrFontList = Split(arrFonts(thePosition), ":")

										thePosition=findInArrayExact(arrFontList,postscriptName)

										if(thePosition = -1)then
											theAction = "An error has occurred, please contact John Ford"
											arrAction = addAction(arrAction, theAction)
										else
											if(thePosition = 0) then
												'dont change, already ok
												theAction = chr(34) & postscriptName & chr(34) & " is correct"
												arrAction = addAction(arrAction, theAction)
											else
												On Error Resume Next
												currentElem.characters(1).appliedFont=arrFontList(0)

												if err.number = 0 then
													theAction = chr(34) & postscriptName & chr(34) & " changed to " & chr(34) & arrFontList(0) & chr(34)
													arrAction = addAction(arrAction, theAction)

													'change the font
													currentElem.characters(myCharCounter).appliedFont=arrFontList(0)
												else
													theAction = chr(34) & arrFontList(0) & chr(34) & " not installed locally"
													arrAction = addAction(arrAction, theAction)
												end if
											end if
										end if
								else
									theAction = chr(34) & displayName & chr(34) & " not found in server list"
									arrAction = addAction(arrAction, theAction)
								end if
							next
						end if
					Next
				Next


				theMessage = ""
				For k=Lbound(arrAction) to Ubound(arrAction)
				    If(arrAction(k) <> "") Then
				        theMessage = theMessage & arrAction(k) & vbCrlf
				    End If
				Next
		
				msgbox(theMessage)
			end if
		end if
	end if
else
	MsgBox ("Please configure your scripts.")
end if


Function addAction(arrayAction, theAction)
	actionFound = findInArrayExact(arrayAction, theAction)
	'actionFound = findInArray(arrayAction, theAction)

	if(actionFound = -1)then
		newSize = Ubound(arrayAction) + 1
		ReDim Preserve arrayAction(newSize)
		arrayAction(newSize)=theAction
	end if

	addAction = arrayAction
End Function


Function CreateGUID
  Dim TypeLib
  Set TypeLib = CreateObject("Scriptlet.TypeLib")
  CreateGUID = Mid(TypeLib.Guid, 2, 36)
End Function


Function findInArray(options, choice)
	thePos = -1

	For j=Lbound(options) to Ubound(options)
	    If(InStr(options(j), choice) <> 0) Then
	        thePos = j
	    End If
	Next

	findInArray = thePos
End Function


Function findInArrayExact(options, choice)
	thePos = -1

	For j=Lbound(options) to Ubound(options)
	    If(options(j) = choice) Then
	        thePos = j
	    End If
	Next

	findInArrayExact = thePos
End Function


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function DownloadLongText(ByVal url)
	Dim returnMe
	Dim errTemp
	Dim xmlhttp
	
	returnMe = ""

	On Error Resume Next
	Set xmlhttp = CreateObject("MSXML2.XMLHTTP")

	errTemp = Err.Number
	If errTemp <> 0 Then
		msgbox("Unable to create scripting object: MSXML2.XMLHTTP")
		msgbox(Err.Description )
	End If

	If errTemp = 0 Then
		Call xmlhttp.Open("GET", url, False)
		errTemp = Err.Number
	End If
	
	If errTemp = 0 Then
		xmlhttp.Send
		errTemp = Err.Number
	End If

	If errTemp = 0 Then
		returnMe = xmlhttp.ResponseText
	End If

	if(false)then
		Set objFSO=CreateObject("Scripting.FileSystemObject")
		outFile="c:\test.txt"
		Set objFile = objFSO.CreateTextFile(outFile,True)
		objFile.Write returnMe & vbCrLf
		objFile.Close
	end if
	
	DownloadLongText = returnMe
End Function


Function checkFileExists(filePathToCheck)
	dim filesys
	dim returnVal
	
	Set filesys = CreateObject("Scripting.FileSystemObject") 

	If filesys.FileExists(filePathToCheck) Then
		returnVal = true
	else
		returnVal = false
	End If 
	
	checkFileExists = returnVal
End Function


Sub DeleteTmpFile(filePathToDelete)
	dim filesys
	
	Set filesys = CreateObject("Scripting.FileSystemObject")
	filesys.CreateTextFile filePathToDelete, True 
	If filesys.FileExists(filePathToDelete) Then
	   filesys.DeleteFile filePathToDelete 
	End If 
End Sub


Sub SillySleep(ByRef seconds)
	Dim WshShell, commandLine
	Set WshShell = CreateObject("Wscript.Shell")
	commandLine = "%COMSPEC% /c ping -n " & 1 + seconds & " 127.0.0.1>nul"
	Call WshShell.Run(commandLine, 0, 1)
End Sub



Function PostFile(ByRef url, ByRef fileObj)
	Dim returnMe
	Dim commandLine
	
	returnMe = ""
	commandLine = "-F upload=@" & chr(34) & fileObj & chr(34) & " " & url
	
	returnMe = CURL(commandLine)

	PostFile = returnMe
End Function



Function CURL(ByVal commandLine)
	Dim returnMe
	Dim errMsg
	Dim WshShell, curlExec, i
	
	returnMe = ""
	theProxy = ReadPref("Server_Proxy")
	
	if theProxy <> "" then
		commandLine = "-x " & theProxy & " " & commandLine
	end if
	
	commandLine = "curl " & commandLine
	Set WshShell = CreateObject("WScript.Shell")
	
	On Error Resume Next
	Set curlExec = WshShell.Exec(commandLine)


	errMsg = Err.Description
	On Error Goto 0
	
	If IsObject(curlExec) Then
		Dim timeLeft
		
		'Time left in seconds
		timeLeft = 120
		Do While (curlExec.Status = 0) And (timeLeft > 0)
			SillySleep(1)
			timeLeft = timeLeft - 1
		Loop

		If (timeLeft > 0) Then
			If (curlExec.ExitCode = 0) Then
				returnMe = curlExec.StdOut.ReadAll
			Else
				Dim errNum, errText
				errText = curlExec.StdOut.ReadAll
				errNum = curlExec.ExitCode
				returnMe = errText
			End If
		Else
			curlExec.Terminate
		End If
	Else
		DisplayError("Unable to find curl.exe")
	End If
	
	CURL = returnMe
End Function

