pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if


if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)

	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then
		'Check one element is selected.
		If myInDesign.Selection.Count = 1 Then
			
			set myElem = myInDesign.Selection.Item(1)
			
			
			if (TypeName(myElem) = "TextFrame") then
				'Check selected element is new or type is text.
				if (myElem.ExtractLabel ("type") = "text") OR (myElem.ExtractLabel ("type") = "") then
					if(myElem.TextFrameIndex = 1) then
						'get the group type from the server
						interfaceType = getInterfaceType(myInDesign)
						
						'remove return at the end
						interfaceType = replace(interfaceType, chr(13), "")
						interfaceType = replace(interfaceType, chr(10), "")
						
						if((interfaceType = "Properties") OR (interfaceType = "Vehicles")) then
							myDisplayDialog myInDesign, myElem, interfaceType
						else
							msgbox("Please configure the document or the group first")
						end if
					else
						MsgBox ("Please select the first linked text box.")
					end if
				else
					MsgBox ("This element has been configured as a " & myElem.ExtractLabel("type") & " elemenet.")
				end if
			else
				MsgBox ("Please select a text element using the selection tool.")
			end if
		Else
			MsgBox ("Please select a text element.")
		End If
	Else
		MsgBox ("Please open a document.")
	End If	
else
	MsgBox ("Please configure your scripts.")
end if



function getInterfaceType(myInDesign)
	groupName = myInDesign.ActiveDocument.ExtractLabel ("group")
	
	if(groupName = "") OR (groupName = "Please Select") Then
		retuenVal = ""
	else
		theURL = ReadPref("Server_URL")
		
		retuenVal = PostForm(theURL & "4dcgi/u_get_group_interface.a4d", "iGroup=""" & groupName & """")
	end if
	
	getInterfaceType = retuenVal
end function

function propertyFieldNames()
	'Set field name values for prop
	dim fieldNameDropDown(74)
	
	fieldNameDropDown(0)="Address"
	fieldNameDropDown(1)="AdvertisingHeading"
	fieldNameDropDown(2)="AgentName"
	fieldNameDropDown(3)="Agent2_Phone"
	fieldNameDropDown(4)="Area"
	fieldNameDropDown(5)="AreaCode"
	fieldNameDropDown(6)="Bathrooms"
	fieldNameDropDown(7)="Bedrooms"
	fieldNameDropDown(8)="City"
	fieldNameDropDown(9)="County"
	fieldNameDropDown(10)="Data1"
	fieldNameDropDown(11)="Description"
	fieldNameDropDown(12)="Directions"
	fieldNameDropDown(13)="Extra Description"
	fieldNameDropDown(14)="Flash 1"
	fieldNameDropDown(15)="Flash 2"
	fieldNameDropDown(16)="Flash 3"
	fieldNameDropDown(17)="Heading"
	fieldNameDropDown(18)="House_name_number"
	fieldNameDropDown(19)="Internet"
	fieldNameDropDown(20)="List"
	fieldNameDropDown(21)="Open_House_Day"
	fieldNameDropDown(22)="OpenHouseTime"
	fieldNameDropDown(23)="Office"
	fieldNameDropDown(24)="Other"
	fieldNameDropDown(25)="Phone"
	fieldNameDropDown(26)="Postcode"
	fieldNameDropDown(27)="Price"
	fieldNameDropDown(28)="Price Prefix"
	fieldNameDropDown(29)="Price Suffix"
	fieldNameDropDown(30)="PropertyAddress"
	fieldNameDropDown(31)="Small_Bullet_1"
	fieldNameDropDown(32)="Small_Bullet_2"
	fieldNameDropDown(33)="Small_Bullet_3"
	fieldNameDropDown(34)="Small_Bullet_4"
	fieldNameDropDown(35)="Small_Bullet_5"
	fieldNameDropDown(36)="Small_Bullet_6"
	fieldNameDropDown(37)="Small_Bullet_7"
	fieldNameDropDown(38)="Small Description"
	fieldNameDropDown(39)="Status"
	fieldNameDropDown(40)="Stock Number"
	fieldNameDropDown(41)="Strap Line"
	fieldNameDropDown(42)="Tenure"
	fieldNameDropDown(43)="Town"
	fieldNameDropDown(44)="WYSIWYG"
	fieldNameDropDown(45)="Group Name"
	fieldNameDropDown(46)="Group Address"
	fieldNameDropDown(47)="Group Telephone"
	fieldNameDropDown(48)="Group Fax"
	fieldNameDropDown(49)="Group Email"
	fieldNameDropDown(50)="Group URL"
	fieldNameDropDown(51)="Pref: Company Name"
	fieldNameDropDown(52)="Pref: Address 1"
	fieldNameDropDown(53)="Pref: Address 2"
	fieldNameDropDown(54)="Pref: Address 3"
	fieldNameDropDown(55)="Pref: Address 4"
	fieldNameDropDown(56)="Pref: Address 5"
	fieldNameDropDown(57)="Pref: Filler Copy"
	fieldNameDropDown(58)="Pref: Headings"
	fieldNameDropDown(59)="Pref: Telephone"
	fieldNameDropDown(60)="Pref: Fax"
	fieldNameDropDown(61)="Pref: Email"
	fieldNameDropDown(62)="Pref: Website"
	fieldNameDropDown(63)="Pref: Custom 1"
	fieldNameDropDown(64)="Pref: Custom 2"
	fieldNameDropDown(65)="Pref: WYSIWYG"
	fieldNameDropDown(66)="First on Page"
	fieldNameDropDown(67)="Last on Page"
	fieldNameDropDown(68)="First Last on Page"
	fieldNameDropDown(69)="sms_address"
	fieldNameDropDown(70)="sms_url"
	fieldNameDropDown(71)="sms_make"
	fieldNameDropDown(72)="sms_model"
	fieldNameDropDown(73)="sms_price"
	fieldNameDropDown(74)="sms_year"

	propertyFieldNames = fieldNameDropDown
end function


function autoFieldNames()
	'Set field name values for autos
	dim fieldNameDropDown(22)
	
	fieldNameDropDown(0)="Description"
	fieldNameDropDown(1)="Features"
	fieldNameDropDown(2)="Financing"
	fieldNameDropDown(3)="Make"
	fieldNameDropDown(4)="Mileage"
	fieldNameDropDown(5)="Model"
	fieldNameDropDown(6)="Price"
	fieldNameDropDown(7)="Trim"
	fieldNameDropDown(8)="VIN"
	fieldNameDropDown(9)="Year"
	fieldNameDropDown(10)="Pref: Company Name"
	fieldNameDropDown(11)="Pref: Address 1"
	fieldNameDropDown(12)="Pref: Address 2"
	fieldNameDropDown(13)="Pref: Address 3"
	fieldNameDropDown(14)="Pref: Address 4"
	fieldNameDropDown(15)="Pref: Address 5"
	fieldNameDropDown(16)="Pref: Telephone"
	fieldNameDropDown(17)="Pref: Fax"
	fieldNameDropDown(18)="Pref: Email"
	fieldNameDropDown(19)="Pref: Website"
	fieldNameDropDown(20)="First on Page"
	fieldNameDropDown(21)="Last on Page"
	fieldNameDropDown(22)="First Last on Page"
	
	autoFieldNames = fieldNameDropDown
end function


Function myDisplayDialog(myInDesign, myObject, interfaceType)
	
	'Set fit method drop down values
	dim fitMethodDropDown(5)
	fitMethodDropDown(0)="None"
	fitMethodDropDown(1)="Adjust By Size"
	fitMethodDropDown(2)="Adjust By Leading"
	fitMethodDropDown(3)="Adjust by Horizontal Scale"
	fitMethodDropDown(4)="Adjust by Word Spacing"
	fitMethodDropDown(5)="Adjust by Tracking"
	
	
	'Set case dropdown
	dim changeCaseDropDown(4)
	changeCaseDropDown(0)="None"
	changeCaseDropDown(1)="Uppercase"
	changeCaseDropDown(2)="Lowercase"
	changeCaseDropDown(3)="Title Case"
	changeCaseDropDown(4)="Sentence Case"
	
	
	'create the field name array
	if(interfaceType = "Properties") then
		fieldNameDropDown = propertyFieldNames()
	else
		fieldNameDropDown = autoFieldNames()
	end if
	
	
	'used by other systems.
	if(InStr(myObject.Label,"<Tag"))then
		myObject.Label = ""
	end if
	
	
	if(myObject.Label = "") then
		'Newly configured element
		setDefaultTxt = myObject.Contents
		
		'get next sort
		setSort = getNextSort("text", myInDesign)

		'set default dingbat
		setDingbat = "\U2022"
	else
		setTxtName = myObject.Label
		setSort = myObject.ExtractLabel ("sort")
		setMaxPointSize = myObject.ExtractLabel ("maxPointSize")
		setDingbat = myObject.ExtractLabel ("dingbat")
	end if
	
	
	setAutoFill = myObject.ExtractLabel ("autoFill")
	setMinPointSize = myObject.ExtractLabel ("minPointSize")
	setMaxPointSize = myObject.ExtractLabel ("maxPointSize")
	setStartOfLine = myObject.ExtractLabel ("startOfLine")
	setsearchReplace = myObject.ExtractLabel ("searchReplace")
	
	
	'Find selected fit method
	setFitMethod = 0	
	For i = LBound(fitMethodDropDown) to UBound(fitMethodDropDown)
		if(fitMethodDropDown(i) = myObject.ExtractLabel ("fitMethod")) then
			setFitMethod = i
		end if
	Next
	
	
	'Find selected case change
	setChangeCase = 0
	For i = LBound(changeCaseDropDown) to UBound(changeCaseDropDown)
		if(changeCaseDropDown(i) = myObject.ExtractLabel ("changeCase")) then
			setChangeCase = i
		end if
	Next
	
	
	'Find selected name value
	setNameVal = 0	
	For i = LBound(fieldNameDropDown) to UBound(fieldNameDropDown)
		if(myObject.Label = "") then
			if(fieldNameDropDown(i) = setDefaultTxt) then
				setNameVal = i
			end if
		else
			if(fieldNameDropDown(i) = myObject.Label) then
				setNameVal = i
			end if
		end if
	Next
		
		
		setSubEdit = false
		if(myObject.ExtractLabel ("subEdit") = "true") then
			setSubEdit = true
		end if
			
			
		Set myDialog = myInDesign.Dialogs.Add
		myDialog.Name = "Configure Text"
		
		With myDialog.DialogColumns.Add
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "Name"
							End With
							With .StaticTexts.Add
								.staticLabel = "Sort"
							End With
							With .StaticTexts.Add
								.staticLabel = "Auto Fill"
							End With
							With .StaticTexts.Add
								.staticLabel = "Dingbat"
							End With
							With .StaticTexts.Add
								.staticLabel = "Start of Line"
							End With						
							With .StaticTexts.Add
								.staticLabel = "Fit Method"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Minimum"
							End With
							With .StaticTexts.Add
								.staticLabel = "Fit Maximum"
							End With
							With .StaticTexts.Add
								.staticLabel = "Search and Replace"
							End With	
							With .StaticTexts.Add
								.staticLabel = "Change Case"
							End With	
							With .StaticTexts.Add
								.staticLabel = "Sub-Editing"
							End With							
						End With
						With .DialogColumns.Add
							Set txtName = .dropdowns.Add
							With txtName
								.StringList = fieldNameDropDown
								.selectedIndex = setNameVal
								.MinWidth = 350
							End With
							Set txtSort = .TextEditboxes.Add
							With txtSort
								.EditContents = setSort
							End With
							Set autoFill = .TextEditboxes.Add
							With autoFill
								.EditContents = setAutoFill
								.MinWidth = 350
							End With
							Set dingbat = .TextEditboxes.Add
							With dingbat
								.EditContents = setDingbat
								.MinWidth = 350
							End With
							Set startOfLine = .TextEditboxes.Add
							With startOfLine
								.EditContents = setStartOfLine
								.MinWidth = 350
							End With
							Set fitMethod = .dropdowns.Add
							With fitMethod
								.StringList = fitMethodDropDown
								.selectedIndex = setFitMethod
								.MinWidth = 350
							End With
							Set minPointSize = .TextEditboxes.Add
							With minPointSize
								.EditContents = setMinPointSize
							End With
							Set maxPointSize = .TextEditboxes.Add
							With maxPointSize
								.EditContents = setMaxPointSize
							End With
							Set searchReplace = .TextEditboxes.Add
							With searchReplace
								.EditContents = setSearchReplace
								.MinWidth = 350
							End With
							Set changeCase = .dropdowns.Add
							With changeCase
								.StringList = changeCaseDropDown
								.selectedIndex = setChangeCase
								.MinWidth = 350
							End With							
							Set subEdit = .checkboxControls.Add
							With subEdit
								.checkedState = setSubEdit
							End With						
						End With
					End With
				End With
			End With
			
			
			if myObject.RotationAngle <> 0 then
				With .BorderPanels.Add
					With .DialogColumns.Add
						With .DialogRows.Add
							With .DialogColumns.Add
								With .StaticTexts.Add
									.staticLabel = "*PLEASE ROTATE ELEMENTS FROM THE LOWER LEFT CORNER"
								End With
							End With

						End With
					End With
				End With
			end if
	
	
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "CLEAR ALL CONFIGURED DATA?"
							End With
						End With
						With .DialogColumns.Add
							Set clearData = .checkboxControls.Add
							With clearData
								.checkedState = false
							End With
						End With
					End With
				End With
			End With
		End With
	
		myReturn = myDialog.Show
		
		If myReturn = True Then
			'Get the values from the dialog box.
			
			if(clearData.checkedState = true) then
				
				clearIt = MsgBox("Are you sure you want to clear all of the configured data for this element?", vbYesNo, "Clear Data")
				continueOn = (clearIt = vbYes)
				
				if continueOn then
					myObject.Label = ""
					myObject.InsertLabel "type", ""
					myObject.InsertLabel "sort", ""
					myObject.InsertLabel "autoFill", ""
					myObject.InsertLabel "dingbat", ""
					myObject.InsertLabel "startOfLine", ""
					myObject.InsertLabel "minPointSize", ""
					myObject.InsertLabel "maxPointSize", ""
					myObject.InsertLabel "fitMethod", ""
					myObject.InsertLabel "subEdit", ""
					myObject.InsertLabel "searchReplace", ""
					myObject.InsertLabel "changeCase", ""
				end if			
			else
					if (txtSort.EditContents <> "") then
						myObject.Label = fieldNameDropDown(txtName.selectedIndex)
						
						myObject.InsertLabel "type", "text"
						myObject.InsertLabel "sort", txtSort.EditContents
						myObject.InsertLabel "autoFill", autoFill.EditContents
						myObject.InsertLabel "dingbat", dingbat.EditContents
						myObject.InsertLabel "startOfLine", startOfLine.EditContents
						myObject.InsertLabel "minPointSize", minPointSize.EditContents
						myObject.InsertLabel "maxPointSize", maxPointSize.EditContents
						myObject.InsertLabel "fitMethod", fitMethodDropDown(fitMethod.selectedIndex)
						myObject.InsertLabel "changeCase", changeCaseDropDown(changeCase.selectedIndex)
						myObject.InsertLabel "searchReplace", searchReplace.EditContents
						
						'2.5 testing
						myObject.InsertLabel "numberOfLines", "5"
						myObject.InsertLabel "characterWidth", "20"
						
						if(subEdit.checkedState = true) then
							myObject.InsertLabel "subEdit", "true"
						else
							myObject.InsertLabel "subEdit", "false"
						end if
					else
						MsgBox ("Sort order cannot be blank.")
					end if
			end if
		End If
End Function






Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function getNextSort (theType, myInDesign)
	dim finalSort, myCounter, elemType
	
	finalSort = 0
	
	'Loop through elements on current document
	For myCounter = 1 To myInDesign.ActiveDocument.PageItems.Count
		elemType = myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("type")
		
		if(elemType = theType) then
			newSort = cInt(myInDesign.ActiveDocument.PageItems.Item(myCounter).ExtractLabel ("sort"))
			
			if (newSort > finalSort) then
				finalSort = newSort
			end if
		end if	
	Next
	
	finalSort = finalSort + 1
	
	getNextSort = CStr(finalSort)
End Function




Function PostForm(ByRef url, ByRef formData)
	Dim returnMe, formText, commandLine
	
	returnMe = ""

	If IsArray(formData) Then
		formText = MakeFormText(formData)
	Else
		formText = formData
	End If

	commandLine = "-F " & formText & " " & url	
	
	returnMe = CURL(commandLine)

	PostForm = returnMe
End Function




Function CURL(ByVal commandLine)
	Dim returnMe
	Dim errMsg
	Dim WshShell, curlExec, i
	
	returnMe = ""
	theProxy = ReadPref("Server_Proxy")
	
	if theProxy <> "" then
		commandLine = "-x " & theProxy & " " & commandLine
	end if
	
	commandLine = "curl " & commandLine
	Set WshShell = CreateObject("WScript.Shell")
	
	On Error Resume Next
	Set curlExec = WshShell.Exec(commandLine)


	errMsg = Err.Description
	On Error Goto 0
	
	If IsObject(curlExec) Then
		Dim timeLeft
		
		'Time left in seconds
		timeLeft = 120
		Do While (curlExec.Status = 0) And (timeLeft > 0)
			SillySleep(1)
			timeLeft = timeLeft - 1
		Loop

		If (timeLeft > 0) Then
			If (curlExec.ExitCode = 0) Then
				returnMe = curlExec.StdOut.ReadAll
			Else
				Dim errNum, errText
				errText = curlExec.StdOut.ReadAll
				errNum = curlExec.ExitCode
				returnMe = errText
			End If
		Else
			curlExec.Terminate
		End If
	Else
		msgbox("Unable to find curl.exe")
	End If
	
	CURL = returnMe
End Function



Sub SillySleep(ByRef seconds)
	Dim WshShell, commandLine
	Set WshShell = CreateObject("Wscript.Shell")
	commandLine = "%COMSPEC% /c ping -n " & 1 + seconds & " 127.0.0.1>nul"
	Call WshShell.Run(commandLine, 0, 1)
End Sub