pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if


if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)

	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then
	
		'Check one element is selected.
		If myInDesign.Selection.Count = 1 Then
			
			set myElem = myInDesign.Selection.Item(1)
			
			'Check selected element is new or type is text.
			if (myElem.ExtractLabel ("type") = "generic") OR (myElem.ExtractLabel ("type") = "") then
				
				'Check selected element is the right type.
				Select Case TypeName(myElem)
				Case "Rectangle", "Oval", "Polygon"
					myDisplayDialog myInDesign, myElem
				Case Else
					MsgBox ("Please select an image element.")
				End Select
			else
				MsgBox ("This element has been configured as a " & myElem.ExtractLabel("type") & " elemenet.")
			end if
		Else
			MsgBox ("Please select an image element.")
		End If
	Else
		MsgBox ("Please open a document.")
	End If
	
	Function myDisplayDialog(myInDesign, myObject)
		
		if(myObject.Label = "") then
			'Newly configured element
			setGeneric = false
		else
			setGeneric = true
		end if
		
		
		Set myDialog = myInDesign.Dialogs.Add
		myDialog.Name = "Configure Element"
		
		With myDialog.DialogColumns.Add
			With .BorderPanels.Add
				With .DialogColumns.Add
					With .DialogRows.Add
						With .DialogColumns.Add
							With .StaticTexts.Add
								.staticLabel = "Generic Element"
							End With						
						End With
						With .DialogColumns.Add
							Set makeGeneric = .checkboxControls.Add
							With makeGeneric
								.checkedState = setGeneric                       
							End With					
						End With
					End With
				End With
			End With
		End With
	
		myReturn = myDialog.Show
		
		If myReturn = True Then
			'correct colour swatch used.
			if(myObject.FillColor.name = "Primary Colour") OR (myObject.FillColor.name = "primary colour") OR (myObject.FillColor.name = "Secondary Colour") OR (myObject.FillColor.name = "secondary colour") OR (myObject.FillColor.name = "Tertiary Colour") OR (myObject.FillColor.name = "tertiary colour") OR (myObject.FillColor.name = "Quaternary Colour") OR (myObject.FillColor.name = "quaternary colour") OR (myObject.FillColor.name = "GC1") OR (myObject.FillColor.name = "gc1") OR (myObject.FillColor.name = "GC2") OR (myObject.FillColor.name = "gc2") OR (myObject.FillColor.name = "GC3") OR (myObject.FillColor.name = "gc3") OR (myObject.FillColor.name = "GC4") OR (myObject.FillColor.name = "gc4") OR (myObject.FillColor.name = "GC5") OR (myObject.FillColor.name = "gc5") OR (myObject.FillColor.name = "GC6") OR (myObject.FillColor.name = "gc6") OR (myObject.FillColor.name = "GC7") OR (myObject.FillColor.name = "gc7") OR (myObject.FillColor.name = "GC8") OR (myObject.FillColor.name = "gc8") OR (myObject.FillColor.name = "GC9") OR (myObject.FillColor.name = "gc9") OR (myObject.FillColor.name = "GC10") OR (myObject.FillColor.name = "gc10")then
				correctSwatch = true
			else
				correctSwatch = false
				msgbox("Primary, secondary, tertiary or quarternary colour swatch not used.")
			end if
			
			
			'Get the values from the dialog box.
			if(makeGeneric.checkedState = true) AND (correctSwatch) then
					myObject.Label = "generic"
					myObject.InsertLabel "type", "generic"
			else
				myObject.Label = ""
				myObject.InsertLabel "type", ""
			end if
		End If
	End Function
else
	MsgBox ("Please configure your scripts.")
end if



Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function