pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if

if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)
	
	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then
		set mySwatches = myInDesign.Documents(1).swatches

		copyAll = MsgBox("Please confirm that the current document contains the swatches you would like to copy?", vbYesNo, "Copy Swatches")
		
		if(copyAll = vbYes)then

			'loop swatches
			For swatchCount = 1 To mySwatches.count
				colourName = mySwatches(swatchCount).name

				'loop docs, dont import into first doc as that contains the originals
				For docCount = 2 To myInDesign.Documents.Count
					if(createColour(colourName, myInDesign.Documents(docCount)))then 
						set myColour = myInDesign.Documents(docCount).colors.add()
		        		myColour.name = colourName
		        		myColour.space = mySwatches(swatchCount).space
		        		myColour.colorValue = mySwatches(swatchCount).colorValue
		        		myColour.model = mySwatches(swatchCount).model
					end if
				next
			Next

			msgbox("Finished")
		end if
	end if
else
	MsgBox ("Please configure your scripts.")
end if


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function



Function createColour(colourName, doc)
	returnValue = false

	if((colourName <> "None") AND (colourName <> "Registration") AND (colourName <> "Paper") AND (colourName <> "Black"))then
		On Error Resume Next
		existColour = doc.swatches.item(colourName).name

		if err.number <> 0 then
			returnValue = true
		end if
	end if

	createColour = returnValue
End Function