pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if


Dim arrAction
arrAction = Array("Complete:")

if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)
	
	'Check document is open.
	If myInDesign.Documents.Count <> 0 Then

		'Set page count
		set allPages = myInDesign.ActiveDocument.Pages

		'Loop through pages
		For myPageCount = 1 To allPages.Count

			set allElems = myInDesign.ActiveDocument.Pages(CInt(myPageCount)).PageItems
			
			'loop through all elements
			For myCounter = 1 To allElems.Count
				set currentElem = allElems(myCounter)
				
				if (TypeName(currentElem) = "TextFrame") then

					if(currentElem.contents = "")then
						currentElem.contents = "a"
					end if

					For myCharCounter = 1 To currentElem.characters.count
						'Get postscript name
						postscriptName = currentElem.characters(myCharCounter).appliedFont
						
						displayName = Replace(postscriptName,vbTab,"{tab}")
						displayName = Replace(displayName, " ","{space}")
						
						arrAction = addAction(arrAction, displayName)
					next
				end if
			Next
		Next


		theMessage = ""
		For k=Lbound(arrAction) to Ubound(arrAction)
		    If(arrAction(k) <> "") Then
		        theMessage = theMessage & arrAction(k) & vbCrlf
		    End If
		Next

		msgbox(theMessage)
	end if
else
	MsgBox ("Please configure your scripts.")
end if


Function addAction(arrayAction, theAction)
	actionFound = findInArray(arrayAction, theAction)
	
	if(actionFound = -1)then
		newSize = Ubound(arrayAction) + 1
		ReDim Preserve arrayAction(newSize)
		arrayAction(newSize)=theAction
	end if

	addAction = arrayAction
End Function


Function CreateGUID
  Dim TypeLib
  Set TypeLib = CreateObject("Scriptlet.TypeLib")
  CreateGUID = Mid(TypeLib.Guid, 2, 36)
End Function


Function findInArray(options, choice)
	thePos = -1

	For j=Lbound(options) to Ubound(options)
	    If(options(j) = choice) Then
	        thePos = j
	    End If
	Next

	findInArray = thePos
End Function


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Function DownloadLongText(ByVal url)
	Dim returnMe
	Dim errTemp
	Dim xmlhttp
	
	returnMe = ""

	On Error Resume Next
	Set xmlhttp = CreateObject("MSXML2.XMLHTTP")

	errTemp = Err.Number
	If errTemp <> 0 Then
		msgbox("Unable to create scripting object: MSXML2.XMLHTTP")
		msgbox(Err.Description )
	End If

	If errTemp = 0 Then
		Call xmlhttp.Open("GET", url, False)
		errTemp = Err.Number
	End If
	
	If errTemp = 0 Then
		xmlhttp.Send
		errTemp = Err.Number
	End If

	If errTemp = 0 Then
		returnMe = xmlhttp.ResponseText
	End If

	if(false)then
		Set objFSO=CreateObject("Scripting.FileSystemObject")
		outFile="c:\test.txt"
		Set objFile = objFSO.CreateTextFile(outFile,True)
		objFile.Write returnMe & vbCrLf
		objFile.Close
	end if
	
	DownloadLongText = returnMe
End Function


Function checkFileExists(filePathToCheck)
	dim filesys
	dim returnVal
	
	Set filesys = CreateObject("Scripting.FileSystemObject") 

	If filesys.FileExists(filePathToCheck) Then
		returnVal = true
	else
		returnVal = false
	End If 
	
	checkFileExists = returnVal
End Function


Sub DeleteTmpFile(filePathToDelete)
	dim filesys
	
	Set filesys = CreateObject("Scripting.FileSystemObject")
	filesys.CreateTextFile filePathToDelete, True 
	If filesys.FileExists(filePathToDelete) Then
	   filesys.DeleteFile filePathToDelete 
	End If 
End Sub


Sub SillySleep(ByRef seconds)
	Dim WshShell, commandLine
	Set WshShell = CreateObject("Wscript.Shell")
	commandLine = "%COMSPEC% /c ping -n " & 1 + seconds & " 127.0.0.1>nul"
	Call WshShell.Run(commandLine, 0, 1)
End Sub



Function PostFile(ByRef url, ByRef fileObj)
	Dim returnMe
	Dim commandLine
	
	returnMe = ""
	commandLine = "-F upload=@" & chr(34) & fileObj & chr(34) & " " & url
	
	returnMe = CURL(commandLine)

	PostFile = returnMe
End Function



Function CURL(ByVal commandLine)
	Dim returnMe
	Dim errMsg
	Dim WshShell, curlExec, i
	
	returnMe = ""
	theProxy = ReadPref("Server_Proxy")
	
	if theProxy <> "" then
		commandLine = "-x " & theProxy & " " & commandLine
	end if
	
	commandLine = "curl " & commandLine
	Set WshShell = CreateObject("WScript.Shell")
	
	On Error Resume Next
	Set curlExec = WshShell.Exec(commandLine)


	errMsg = Err.Description
	On Error Goto 0
	
	If IsObject(curlExec) Then
		Dim timeLeft
		
		'Time left in seconds
		timeLeft = 120
		Do While (curlExec.Status = 0) And (timeLeft > 0)
			SillySleep(1)
			timeLeft = timeLeft - 1
		Loop

		If (timeLeft > 0) Then
			If (curlExec.ExitCode = 0) Then
				returnMe = curlExec.StdOut.ReadAll
			Else
				Dim errNum, errText
				errText = curlExec.StdOut.ReadAll
				errNum = curlExec.ExitCode
				returnMe = errText
			End If
		Else
			curlExec.Terminate
		End If
	Else
		DisplayError("Unable to find curl.exe")
	End If
	
	CURL = returnMe
End Function

