pP2PrefsRegistryKey = "HKCU\Software\DND\InDesign_ProMotor\"
'SET THE VERSION HERE:
theVersion = ""
'theVersion = "4"
'theVersion = "CC"
'theVersion = "CC.2014"

if(theVersion = "")then
	'Load the version
	theVersion = ReadPref("ID_Version")
end if


'test version has been set
if (theVersion <> "") then

	Set myInDesign = CreateObject("InDesign.Application." & theVersion)

	
	'test for active document
	If myInDesign.Documents.Count <> 0 Then	
				
		inDesignPath = myInDesign.FilePath
		scriptPath = inDesignPath & "\Scripts\Scripts Panel\4D\Upload.vbs"

		if(Not(checkFileExists(scriptPath)))then
			scriptPath = inDesignPath & "\Scripts\Scripts Panel\EzAdsPro\Upload.vbs"
		end if

		if(Not(checkFileExists(scriptPath)))then
			scriptPath = inDesignPath & "\Scripts\Scripts Panel\Upload.vbs"
		end if

		if(Not(checkFileExists(scriptPath)))then
			scriptPath = inDesignPath & "\Scripts\Scripts Panel\ProMotor\Upload.vbs"
		end if

		if(Not(checkFileExists(scriptPath)))then
			scriptPath = "c:\Scripts\Scripts Panel\EzAdsPro\Upload.vbs"
		end if

		'jf
		if(Not(checkFileExists(scriptPath)))then
			scriptPath = "C:\Program Files (x86)\Adobe\Adobe InDesign CS4\Scripts\Scripts Panel\4D\Upload.vbs"
		end if

		'msgbox(scriptPath)

		if(checkFileExists(scriptPath))then
			
			goOn = MsgBox("Are you sure you want to upload all open documents?", vbYesNo, "Upload All")
			if(goOn = vbYes) then

				'doc count
				totalDocs = myInDesign.Documents.Count

				'changing the active document alters the odcument offsets
				dim allDocs()
	    		ReDim allDocs(totalDocs)
				For docCount = 1 To totalDocs
					set allDocs(docCount) = myInDesign.Documents(docCount)
				next
				
				'loop open docs
				For docCount = 1 To totalDocs
					myInDesign.ActiveDocument = allDocs(docCount)

					'run the upload script
					Set objShell = CreateObject("WScript.Shell")
					returnVal = objShell.Run("cscript " & chr(34) & scriptPath & chr(34), 1, 1)
					Set objShell = Nothing
				Next
			end if

			msgbox("Upload All Complete")
		Else
			MsgBox ("Failed to locate upload script.")
		End If
	Else
		MsgBox ("Please open a document.")
	End If
else
	MsgBox ("Please configure your scripts.")
end if


Function checkFileExists(filePathToCheck)
	dim filesys
	dim returnVal
	
	Set filesys = CreateObject("Scripting.FileSystemObject") 

	If filesys.FileExists(filePathToCheck) Then
		returnVal = true
	else
		returnVal = false
	End If 
	
	checkFileExists = returnVal
End Function


Function ReadPref(theKey)
	Dim wsh
	Dim returnMe
	Set wsh = CreateObject("WScript.Shell")
	
	On Error Resume Next
		returnMe = wsh.RegRead(pP2PrefsRegistryKey & theKey)
	On Error Goto 0
	
	ReadPref = returnMe
End Function


Sub WritePref(ByRef theKey, ByRef newValue)
		Dim wsh
		Set wsh = CreateObject("WScript.Shell")
	
		Call wsh.RegWrite(pP2PrefsRegistryKey & theKey, newValue)
End Sub